ServerEvents.recipes(event => { //listen for the "recipes" server event.
    // You can replace `event` with any name you like, as 
    // long as you change it inside the callback too!
    
    // This part, inside the curly braces, is the callback.
    // You can modify as many recipes as you like in here,
    // without needing to use ServerEvents.recipes() again.
    event.shaped(
        Item.of('mcwwindows:bamboo_shutter',), // arg 1: output
        [ 
          ' BB', 
          ' BB', // arg 2: the shape (array of strings)
          ' BB'  
        ],
        {
          B: 'minecraft:bamboo',   
        })

        event.remove({id: 'mcwwindows:bamboo_shutter'})

          event.shaped(
            Item.of('untamedwilds:debug_analyzer',), // arg 1: output
            [ 
              'FEF', 
              'EDE', // arg 2: the shape (array of strings)
              'AEA'  
            ],
            {
              A: 'minecraft:iron_ingot',
              D: 'minecraft:nether_star',
              E: 'minecraft:glass',
              F: 'untamedwilds:flora_common_reed',   
            })
    event.shaped(
        Item.of('xercapaint:item_palette',), // arg 1: output
        [ 
          'GGG', 
          'GGG', // arg 2: the shape (array of strings)
          'GGG'  
        ],
        {
          G: 'minecraft:oak_planks',   
        })
    event.shapeless('pamhc2foodcore:flouritem', [
      'pamhc2foodcore:grinderitem',
      'minecraft:wheat'
    ])
          event.remove({id: 'beachparty:radio'})
          event.remove({id: 'framedblocks:framed_cube'})
          event.remove({id: 'endermanoverhaul:corrupted_shield'})
          event.remove({id: 'endermanoverhaul:corrupted_blade'})
          event.remove({id: 'endermanoverhaul:enderman_tooth'})
          event.remove({id: 'framedblocks:framed_slope'})
          event.remove({id: 'framedblocks:framed_corner_slope'})
          event.remove({id: 'framedblocks:framed_inner_corner_slope'})
          event.remove({id: 'framedblocks:framed_prism_corner'})
          event.remove({id: 'framedblocks:framed_inner_prism_corner'})
          event.remove({id: 'framedblocks:framed_threeway_corner'})
          event.remove({id: 'framedblocks:framed_inner_threeway_corner'})
          event.remove({id: 'framedblocks:framed_slab_edge'})
          event.remove({id: 'framedblocks:framed_slab_corner'})
          event.remove({id: 'framedblocks:framed_divided_slab'})
          event.remove({id: 'framedblocks:framed_corner_pillar'})
          event.remove({id: 'framedblocks:framed_divided_panel_horizontal'})
          event.remove({id: 'framedblocks:framed_divided_panel_vertical'})
          event.remove({id: 'framedblocks:framed_double_stairs'})
          event.remove({id: 'framedblocks:framed_half_stairs'})
          event.remove({id: 'framedblocks:framed_divided_stairs'})
          event.remove({id: 'framedblocks:framed_vertical_double_stairs'})
          event.remove({id: 'framedblocks:framed_vertical_half_stairs'})
          event.remove({id: 'framedblocks:framed_vertical_divided_stairs'})
          event.remove({id: 'framedblocks:framed_fence_gate'})
          event.remove({id: 'framedblocks:framed_door'})
          event.remove({id: 'framedblocks:framed_iron_door'})
          event.remove({id: 'framedblocks:framed_trapdoor'})
          event.remove({id: 'framedblocks:framed_iron_trapdoor'})
          event.remove({id: 'framedblocks:framed_pressure_plate'})
          event.remove({id: 'framedblocks:framed_stone_pressure_plate'})
          event.remove({id: 'framedblocks:framed_obsidian_pressure_plate'})
          event.remove({id: 'framedblocks:framed_gold_pressure_plate'})
          event.remove({id: 'framedblocks:framed_obsidian_pressure_plate'})
          event.remove({id: 'framedblocks:framed_iron_pressure_plate'})
          event.remove({id: 'framedblocks:framed_ladder'})
          event.remove({id: 'framedblocks:framed_button'})
          event.remove({id: 'framedblocks:framed_stone_button'})
          event.remove({id: 'framedblocks:framed_door'})
          event.remove({id: 'framedblocks:framed_large_button'})
          event.remove({id: 'framedblocks:framed_large_stone_button'})
          event.remove({id: 'framedblocks:framed_door'})
          event.remove({id: 'framedblocks:framed_lever'})
          event.remove({id: 'framedblocks:framed_sign'})
          event.remove({id: 'framedblocks:framed_hangging_sign'})
          event.remove({id: 'framedblocks:framed_double_slope'})
          event.remove({id: 'framedblocks:framed_double_corner'})
          event.remove({id: 'framedblocks:framed_double_prism_corner'})
          event.remove({id: 'framedblocks:framed_double_threeway_corner'})
          event.remove({id: 'framedblocks:framed_torch'})
          event.remove({id: 'framedblocks:framed_soul_torch'})
          event.remove({id: 'framedblocks:framed_redstone_torch'})
          event.remove({id: 'framedblocks:framed_floor_board'})
          event.remove({id: 'framedblocks:framed_wall_board'})
          event.remove({id: 'framedblocks:framed_fence'})
          event.remove({id: 'framedblocks:framed_lattice_block'})
          event.remove({id: 'framedblocks:framed_thick_lattice'})
          event.remove({id: 'framedblocks:framed_chest'})
          event.remove({id: 'framedblocks:framed_secret_storage'})
          event.remove({id: 'framedblocks:framed_bars'})
          event.remove({id: 'framedblocks:framed_horizontal_pane'})
          event.remove({id: 'framedblocks:framed_rail_slope'})
          event.remove({id: 'framedblocks:framed_powered_rail_slope'})
          event.remove({id: 'framedblocks:framed_detector_rail_slope'})
          event.remove({id: 'framedblocks:framed_activator_rail_slope'})
          event.remove({id: 'framedblocks:framed_flower_pot'})
          event.remove({id: 'framedblocks:framed_half_pillar'})
          event.remove({id: 'framedblocks:framed_collapsible_block'})
          event.remove({id: 'framedblocks:framed_bouncy_cube'})
          event.remove({id: 'framedblocks:framed_redstone_block'})
          event.remove({id: 'framedblocks:framed_prism'})
          event.remove({id: 'framedblocks:framed_inner_prism'})
          event.remove({id: 'framedblocks:framed_double_prism'})
          event.remove({id: 'framedblocks:framed_sloped_prism'})
          event.remove({id: 'framedblocks:framed_inner_sloped_prism'})
          event.remove({id: 'framedblocks:framed_double_sloped_prism'})
          event.remove({id: 'framedblocks:framed_sloped_slab'})
          event.remove({id: 'framedblocks:framed_elevated_slope_slab'})
          event.remove({id: 'framedblocks:framed_double_slope_slab'})
          event.remove({id: 'framedblocks:framed_inv_double_slope_slab'})
          event.remove({id: 'framedblocks:framed_elevated_double_slope_slab'})
          event.remove({id: 'framedblocks:framed_stacked_slope_slab'})
          event.remove({id: 'framedblocks:framed_flat_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_elev_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_inner_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_elev_inner_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_double_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_inv_double_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_elev_double_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_elev_inner_double_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_stacked_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_flat_stacked_inner_slope_slab_corner'})
          event.remove({id: 'framedblocks:framed_slope_panel'})
          event.remove({id: 'framedblocks:framed_extended_slope_panel'})
          event.remove({id: 'framedblocks:framed_double_slope_panel'})
          event.remove({id: 'framedblocks:framed_inv_double_slope_panel'})
          event.remove({id: 'framedblocks:framed_slope_extended_double_panel'})
          event.remove({id: 'framedblocks:framed_stacked_slope_panel'})
          event.remove({id: 'framedblocks:framed_flat_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_inner_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_ext_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_ext_inner_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_ext_double_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_ext_inner_double_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_stacked_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_flat_stacked_inner_slope_panel_corner'})
          event.remove({id: 'framedblocks:framed_small_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_large_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_small_inner_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_large_inner_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_ext_inner_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_ext_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_small_double_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_large_double_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_inv_double_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_ext_double_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_ext_inner_double_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_stacked_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_stacked_inner_corner_slope_panel'})
          event.remove({id: 'framedblocks:framed_pyramid'})
          event.remove({id: 'framedblocks:framed_pyramid_slab'})
          event.remove({id: 'framedblocks:framed_target'})
          event.remove({id: 'framedblocks:framed_gate'})
          event.remove({id: 'framedblocks:framed_iron_gate'})
          event.remove({id: 'framedblocks:framed_item_frame'})
          event.remove({id: 'framedblocks:framed_glowing_item_frame'})
          event.remove({id: 'framedblocks:framed_fancy_rail'})
          event.remove({id: 'framedblocks:framed_fancy_powered_rail'})
          event.remove({id: 'framedblocks:framed_fancy_detector_rail'})
          event.remove({id: 'framedblocks:framed_fancy_activator_rail'})
          event.remove({id: 'framedblocks:framed_fancy_rail_slope'})
          event.remove({id: 'framedblocks:framed_fancy_powered_rail_slope'})
          event.remove({id: 'framedblocks:framed_fancy_detector_rail_slope'})
          event.remove({id: 'framedblocks:framed_fancy_activator_rail_slope'})
          event.remove({id: 'framedblocks:framed_half_slope'})
          event.remove({id: 'framedblocks:framed_divided_slope'})
          event.remove({id: 'framedblocks:framed_double_half_slope'})
          event.remove({id: 'framedblocks:framed_glowing_cube'})
          event.remove({id: 'framedblocks:framed_sloped_stairs'})
          event.remove({id: 'framedblocks:framed_vertical_sloped_stairs'})
          event.remove({id: 'framedblocks:framed_mini_cube'})
          event.remove({id: 'framedblocks:framed_one_way_window'})
          event.remove({id: 'framedblocks:framed_bookshelf'})
          event.remove({id: 'framedblocks:framed_chiseled_bookshelf'})
          event.remove({id: 'framedblocks:framed_centered_slab'})
          event.remove({id: 'framedblocks:framed_centered_panel'})
          event.remove({id: 'framedblocks:framing_saw'})
          event.remove({id: 'framedblocks:powered_framing_saw'})

          event.shaped(
            Item.of('4x framedblocks:framed_fence',), // arg 1: output
            [ 
              '   ', 
              'ABA', // arg 2: the shape (array of strings)
              'ABA'  
            ],
            { 
              A: 'framedblocks:framed_cube',
              B: 'minecraft:stick',   
            })
            event.shaped(
              Item.of('4x framedblocks:framed_pillar',), // arg 1: output
              [ 
                '   ', 
                ' A ', // arg 2: the shape (array of strings)
                ' A '  
              ],
              { 
                A: 'framedblocks:framed_cube',   
              })
              event.shaped(
                Item.of('disenchanting_table:disenchanting_table',), // arg 1: output
                [ 
                  ' A ', 
                  'BCB', // arg 2: the shape (array of strings)
                  'CCC'  
                ],
                {
                  A: 'minecraft:lapis_lazuli',
                  B: 'minecraft:diamond_block',
                  C: 'minecraft:obsidian'
    
                })
                event.shaped(
                  Item.of('4x framedblocks:framed_cube',), // arg 1: output
                  [ 
                    'BBB', 
                    'B B', // arg 2: the shape (array of strings)
                    'BBB'  
                  ],
                  { 
                    B: 'minecraft:stick',   
                  })
     event.shaped(
       Item.of('4x alexscaves:rusty_scrap_metal',), // arg 1: output
         [ 
          ' A ', 
          'ABA', // arg 2: the shape (array of strings)
          ' A '  
          ],
          {
          A: 'minecraft:copper_ingot',
          B: 'minecraft:iron_ingot'
         })
         event.shaped(
          Item.of('4x alexscaves:rusty_rebar',), // arg 1: output
            [ 
             ' A ', 
             ' A ', // arg 2: the shape (array of strings)
             '   '  
             ],
             {
             A: 'alexscaves:rusty_scrap_metal'
            })
            event.shaped(
              Item.of('16x alexscaves:rusty_scaffolding',), // arg 1: output
                [ 
                 'AAA', 
                 'B B', // arg 2: the shape (array of strings)
                 'B B'  
                 ],
                 {
                 A: 'alexscaves:rusty_scrap_metal',
                 B: 'alexscaves:rusty_rebar'
                })
                event.shaped(
                  Item.of('alexscaves:rusty_barrel',), // arg 1: output
                    [ 
                     ' A ', 
                     ' B ', // arg 2: the shape (array of strings)
                     '   '  
                     ],
                     {
                     A: 'alexscaves:rusty_scrap_metal',
                     B: 'minecraft:barrel'
                    })
                    event.shaped(
                      Item.of('2x kubejs:empty_sake_bottle',), // arg 1: output
                      [ 
                        ' A ', 
                        'A A', // arg 2: the shape (array of strings)
                        'AAA'  
                      ],
                      {
                        A: 'minecraft:cobbled_deepslate',   
                      })
 event.shaped(
   Item.of('4x kubejs:empty_sake_bowl',), // arg 1: output
   [ 
  '   ', 
  'A A', // arg 2: the shape (array of strings)
  ' A '  
   ],
  {
   A: 'minecraft:cobbled_deepslate',   
   })
   event.shaped(
    Item.of('kubejs:sake_bottle',), // arg 1: output
    [ 
   'AB ', 
   '   ', // arg 2: the shape (array of strings)
   '   '  
    ],
   {
    A: 'kubejs:empty_sake_bottle',
    B: 'growthcraft_rice:sake_fluid_bucket'
    }).replaceIngredient('growthcraft_rice:sake_fluid_bucket', 'minecraft:bucket')
    event.shaped(
      Item.of('8x kubejs:sake_bowl',), // arg 1: output
      [ 
     'BBB', 
     'BAB', // arg 2: the shape (array of strings)
     'BBB'  
      ],
     {
      A: 'kubejs:sake_bottle',
      B: 'kubejs:empty_sake_bowl'
      }).replaceIngredient('kubejs:sake_bottle', 'kubejs:empty_sake_bottle')
      event.shaped(
        Item.of('8x kubejs:sake_bowl',),
        [ 
       'BBB', 
       'BAB',
       'BBB'  
        ],
       {
        A: 'growthcraft_rice:sake_fluid_bucket',
        B: 'kubejs:empty_sake_bowl'
        }).replaceIngredient('growthcraft_rice:sake_fluid_bucket', 'minecraft:bucket')
})



